package com.bonait.bnframework.modules.home.fragment.mode;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.text.TextUtils;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.Spinner;

import androidx.annotation.Nullable;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.constant.DataBus;
import com.bonait.bnframework.common.constant.MessageName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_GOODS;
import com.bonait.bnframework.common.db.mode.BPA_GOODSRECIPENAME;
import com.bonait.bnframework.common.db.mode.BPA_GOODSTYPE;
import com.bonait.bnframework.common.db.mode.BPA_MATERIAL;
import com.bonait.bnframework.common.db.res.ResGoodProperty;
import com.bonait.bnframework.common.db.res.ResGoodsRecipe;
import com.bonait.bnframework.common.db.res.ResMaterilas;
import com.bonait.bnframework.common.helper.I.MyClickListener;
import com.bonait.bnframework.common.image.MyBitmapUtils;
import com.bonait.bnframework.common.message.MessageLooper;
import com.bonait.bnframework.common.message.MessageManager;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.bonait.bnframework.common.view.MyLayoutManager;
import com.bonait.bnframework.modules.home.adapter.goodpf_apapter;
import com.bonait.bnframework.modules.home.adapter.newmeatrilselect_adapter;
import com.bonait.bnframework.modules.home.adapter.newneatril_adapter;
import com.bonait.bnframework.modules.home.adapter.xxpf_adapter;
import com.bonait.bnframework.modules.home.fragment.from.ImageChooseActivity;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.Map;

import butterknife.BindView;
import butterknife.ButterKnife;

/**
 * 商品信息展示
 */
public class GoodInformation extends LinearLayout implements MyClickListener{

    //region 界面变量
    /**
     * 商品类型
     */
    public ArrayList<BPA_GOODSTYPE> Types = new ArrayList<>();
    /**
     * 当前物料数据
     */
    public ArrayList<ResMaterilas> resMaterilas = new ArrayList<>();
    /**
     * 属性数据
     */
    ArrayList<ResGoodProperty> bpa_goodproperties = new ArrayList<>();
    /**
     * 确定文本和取消文本的显示内容
     */
    private String yesStr;
    /**
     * 取消按钮
     */
    public Button close_from, xinjian;
    /**
     * 图片
     */
    public ImageView cpfm;
    /**
     * 文本输入框
     */

    public EditText edittext, edittext1,edittext_wl;
    /**
     * 商品分类
     */
    public Spinner editsp_fl;

    /**
     * 点击事件
     */
    public MyClickListener mListener = null;
    private View root;


    @BindView(R.id.datatab_pf)
    ListView datatab_pf;


    @BindView(R.id.recycler_view_wl_click)
    RecyclerView recycler_view_wl_click;

    public BPA_GOODSRECIPENAME bpaGoodsrecipename=null;

    @BindView(R.id.edittext_pfmingc)
    EditText edittext_pfmingc;//配方名称
    @BindView(R.id.datatab_sx)
    RecyclerView datatab_sx;
    @BindView(R.id.datatab_xxpf)
    ListView datatab_xxpf;

    //endregion

    //region 私例
    public GoodInformation(Context context, @Nullable AttributeSet attrs) {
        super(context, attrs);
        root = LayoutInflater.from(context).inflate(R.layout.dialog_gooddetails, this);
        ButterKnife.bind(this, root);
    }
    //endregion

    //region 数据校准

    /**
     * 数据验证
     *
     * @return
     */
    public boolean DataVerification() {
        boolean IsSucees = false;
        try {
            if (edittext.getText().toString().isEmpty()) {
                ToastUtils.info("名称不能为空!");
                return false;
            }
            boolean issc = false;
            GetWuLiaoSelect(resMaterilas);

            //resMaterilas
            if (issc == false) {
                ToastUtils.info("必须选择一个物料!");
                return false;
            }
            return true;
        } catch (Exception ex) {
            ToastUtils.error("数据验证异常!" + ex.getMessage());
            return IsSucees;
        }
    }
    //endregion

    //region 初始化设置数据
    /**
     * 数据接口：商品数据
     */
    public BPA_GOODS Data = null;
    /**
     * 上一层界面
     */
    Activity activity_ma=null;
    /**
     * 图片URL
     */
    public String url = "";
    /**
     * 商品类别分类
     */
    Map<String, String> map_fl = new LinkedHashMap<>();

    /**
     * 从外界Activity为Dialog 设置数据
     *
     * @param data
     */
    public void setData(String str, BPA_GOODS data, ArrayList<BPA_GOODSTYPE> types, Activity activity,ArrayList<ResGoodProperty> properties) {
        if (str != null) {
            yesStr = str;
        }
        Data = data;
        Types = types;
        activity_ma = activity;

        for (ResGoodProperty pro:properties)
        {
            if(pro.GoodsTypeId!=null && !pro.GoodsTypeId.isEmpty())
            {
                if(pro.GoodsTypeId.contains(Data.goodtype))
                {
                    bpa_goodproperties.add(pro);
                }
            }else
            {
                bpa_goodproperties.add(pro);
            }
        }

        //初始化界面控件
        initView();
        //初始化界面数据
        initData();
        //初始化界面控件的事件
        initEvent();
        //初始化配方
        Initdata_pf();
    }
    //endregion

    //region 初始化函数
    /**
     * 初始化界面控件
     */
    private void initView() {
        close_from = (Button) findViewById(R.id.close_from);
        xinjian = (Button) findViewById(R.id.xinjian);
        cpfm = findViewById(R.id.cpfm);

        edittext = findViewById(R.id.edittext);
        edittext1 = findViewById(R.id.edittext1);
        editsp_fl = findViewById(R.id.editsp_fl);
        edittext_wl = findViewById(R.id.edittext_wl);
    }

    /**
     * 初始化界面控件的显示数据
     */
    private void initData() {

        map_fl.clear();
        for (BPA_GOODSTYPE item : Types) {
            map_fl.put(item.name, item.id);
        }
        SetAdapter(editsp_fl, map_fl);
        //如果设置按钮的文字
        if (yesStr != null) {
            xinjian.setText(yesStr);
        }

        //数据不为空 那么就是修改
        if (Data != null) {
            edittext.setText(Data.name);
            edittext1.setText(Data.foreignKeyRe);
            new MyBitmapUtils().disPlay(cpfm, Data.url);
            url = Data.url;
            int index = 0;
            for (Map.Entry<String, String> entry : map_fl.entrySet()) {
                String key = entry.getKey();
                String value = entry.getValue();
                if (value.equals(Data.goodtype)) {
                    editsp_fl.setSelection(index);
                }
                index++;
            }
        } else {
            edittext.setText("");
            edittext1.setText("");
            new MyBitmapUtils().disPlay(cpfm, "");
            url = "";
        }

        //查询物料数据
        ArrayList<BPA_MATERIAL> materials = QueryDB.GetMaterialALL();


        if (materials != null && materials.size() > 0) {
            resMaterilas.clear();
            for (BPA_MATERIAL item : materials) {
                ResMaterilas mk = new ResMaterilas();
                mk.name = item.name;
                mk.id = item.id;
                mk.isSelect = false;
                if (Data != null && !Data.materialids.isEmpty()) {
                    if (Data.materialids.contains(item.id)) {
                        mk.isSelect = true;
                    }
                }
                resMaterilas.add(mk);
            }
        }
        GetWuLiaoSelect(resMaterilas);

        MyLayoutManager layout = new MyLayoutManager();
        layout.setAutoMeasureEnabled(true);
        recycler_view_wl_click.setLayoutManager(layout);
        newneatril_adapter adapter = new newneatril_adapter(getContext(), QueryDB.GetMaterialALL(), new MyClickListener() {
            @Override
            public void clickListener(View v, Object data) {
                BPA_MATERIAL m=(BPA_MATERIAL)data;

                ResGoodsRecipe cipe=new ResGoodsRecipe();
                cipe.sort=0;
                cipe.materialID=m.id;
                cipe.materialName=m.name;
                cipe.value="0";
                if (DataBus.getInstance().Recipe==null)
                {
                    DataBus.getInstance().Recipe=new ArrayList<>();
                }
                DataBus.getInstance().Recipe.add(cipe);

                if(adapter4!=null)
                {
                    adapter4.notifyDataSetChanged();
                }
            }

            @Override
            public void clickListenerNew(View v, int k, Object data) {

            }
        });
        recycler_view_wl_click.setAdapter(adapter);


//        MyLayoutManager layout = new MyLayoutManager();
//        layout.setAutoMeasureEnabled(true);
//        recycler_view_wl.setLayoutManager(layout);
//        newmeatrilselect_adapter adapter = new newmeatrilselect_adapter(getContext(), resMaterilas);
//        recycler_view_wl.setAdapter(adapter);
    }

    xxpf_adapter adapter4=null;
    public void InitTab()
    {
        DataBus.getInstance().Recipe.clear();
        if(bpaGoodsrecipename!=null)
        {
            DataBus.getInstance().Recipe = QueryDB.GetGoodsSreciperecipeList(bpaGoodsrecipename.id);

        }else
        {
            for(BPA_MATERIAL wl:resMaterilas)
            {
                if(Data.materialids!=null && !Data.materialids.isEmpty() && Data.materialids.contains(wl.id))
                {
                    ResGoodsRecipe cipe=new ResGoodsRecipe();
                    cipe.sort=0;
                    cipe.materialID=wl.id;
                    cipe.materialName=wl.name;
                    cipe.value="0";
                    cipe.goodsID=Data.id;
                    DataBus.getInstance().Recipe.add(cipe);
                }
            }
        }

        if( DataBus.getInstance().Recipe==null)
        {
            DataBus.getInstance().Recipe=new ArrayList<>();
        }
        adapter4= new xxpf_adapter(getContext(), R.layout.xxpf_item, DataBus.getInstance().Recipe,this);
        datatab_pf.setAdapter(adapter4);
    }


    /**
     * 初始化界面的确定和取消监听器
     */
    private void initEvent() {
        /**
         * 设置确定按钮被点击后，向外界提供监听
         */
        xinjian.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (DataVerification()) {

                    ArrayList<BPA_GOODS> goods = QueryDB.GetGoodsALL();
                    if (Data == null)//新增
                    {
                        boolean isSucess = QueryDB.GetGoodsIs(edittext.getText().toString());
                        if (isSucess) {
                            ToastUtils.info("菜谱名称已存在!");
                            return;
                        }
                        Data = new BPA_GOODS();
                        Data.name = edittext.getText().toString();
                        Data.status = 1;
                        Data.sort = goods.size() + 1;
                        Data.maketime = 180;
                        Data.issc = 1;
                        Data.url = url;
                        Data.foreignKeyRe = edittext1.getText().toString();
                        Data.goodtype = map_fl.get(editsp_fl.getSelectedItem().toString());
                        Data.materialids = ids;
                        QueryDB.AddGoods(Data);
                        if (mListener != null) {
                            mListener.clickListenerNew(v, 1, Data);
                        }
                    } else //修改
                    {
                        Data.name = edittext.getText().toString();
                        Data.status = 1;
                        Data.sort = goods.size() + 1;
                        Data.maketime = 180;
                        Data.issc = 1;
                        Data.url = url;
                        Data.foreignKeyRe = edittext1.getText().toString();
                        Data.goodtype = map_fl.get(editsp_fl.getSelectedItem().toString());
                        Data.materialids = ids;
                        QueryDB.UpdateGoods(Data);
                        if (mListener != null) {
                            mListener.clickListenerNew(v, 1, Data);
                        }
                    }

                }
            }
        });
        /**
         * 关闭窗体
         */
        close_from.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (mListener != null) {
                    mListener.clickListenerNew(v, 0, null);
                }
            }
        });
        /**
         * 选择图片资源
         */
        cpfm.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Intent intent = new Intent(getContext(), ImageChooseActivity.class);
                intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                activity_ma.startActivity(intent);
            }
        });
        /**
         * 图标选择之后
         */
        MessageManager.getInstance().registerMessageReceiver(activity_ma, MessageName.ClickImage, new MessageLooper.OnMessageListener() {
            @Override
            public void onMessage(Object msg) {
                if (msg != null) {
                    url = (String) msg;
                    new MyBitmapUtils().disPlay(cpfm, url);
                }
            }
        });

        /**
         * 下拉框选择之后
         */
        edittext_wl.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                checkboxEdit(edittext_wl);
            }
        });

        MessageManager.getInstance().registerMessageReceiver(activity_ma, MessageName.ClickProperty, new MessageLooper.OnMessageListener() {
            @Override
            public void onMessage(Object msg) {
                if (msg != null) {
                    activity_ma.runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            try {
                                edittext_pfmingc.setText(GetSelectName());
                            } catch (Exception e) {

                            }
                        }
                    });
                }
            }
        });
    }

    /**
     * 初始化配方
     */
    public void Initdata_pf()
    {
        if(Data!=null)
        {
            //根据商品查询配方
            ArrayList<BPA_GOODSRECIPENAME> goodsrecipenames=QueryDB.GetGoodsRecipeNameGoodId(Data.id);
            goodpf_apapter adapter = new goodpf_apapter(getContext(), R.layout.wl_item, goodsrecipenames, this);
            datatab_pf.setAdapter(adapter);
        }
    }
    //endregion

    //region 界面事件
    /**
     * 设置下拉框
     * @param spinner
     * @param map
     */
    public void SetAdapter(Spinner spinner, Map<String, String> map) {
        ArrayAdapter<String> adapter = new ArrayAdapter<>(getContext(), R.layout.spinner_text_item, new ArrayList<>(map.keySet()));
        adapter.setDropDownViewResource(R.layout.spinner_dropdown_item);
        spinner.setAdapter(adapter);
    }

    /**
     * 多选下拉框
     */
    private void checkboxEdit(EditText edit) {
        AlertDialog.Builder builder = new AlertDialog.Builder(getContext());
        builder.setTitle("物料列表");
        DialogInterface.OnMultiChoiceClickListener multiChoiceClickListener = new DialogInterface.OnMultiChoiceClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int i, boolean isChecked) {
                resMaterilas.get(i).isSelect= isChecked;
            }
        };

        // 下拉项选中状态
        boolean[] selected = new boolean[resMaterilas.size()];
        // 下拉框数据源
        String[] str = new String[resMaterilas.size()];

        for (int i = 0; i < resMaterilas.size(); i++) {
            str[i] = resMaterilas.get(i).name;
            selected[i] = resMaterilas.get(i).isSelect;
        }

        builder.setMultiChoiceItems(str, selected, multiChoiceClickListener);
        DialogInterface.OnClickListener clickListener = new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                GetWuLiaoSelect(resMaterilas);
                edit.setText(names);
            }
        };
        builder.setCancelable(false);
        builder.setNegativeButton("取消", null);
        builder.setPositiveButton("确定", clickListener);
        AlertDialog dialog = builder.create();
        dialog.show();
    }

    public String ids = "";
    public String names="";

    /**
     * 获取物料选择
     */
    public void GetWuLiaoSelect(ArrayList<ResMaterilas> materilas)
    {
        ids = "";names="";
        for (ResMaterilas item:materilas)
        {
            if (item.isSelect) {
                if (TextUtils.isEmpty(names)) {
                    names = names + item.name;
                    ids = ids + item.id;
                } else {
                    names = names + "," + item.name;
                    ids = ids + "," + item.id;
                }
            }
        }
        edittext_wl.setText(names);
    }

    /**
     * 获取选中名称
     * @return
     */
    public String GetSelectName()
    {
        String names=Data.name+"_";
        for(ResGoodProperty item:bpa_goodproperties)
        {
            for(ResGoodProperty k:item.child)
            {
                if(k.isSelect)
                {
                    names+=k.name+"_";
                }
            }
        }
        return names.substring(0, names.length() - 1);
    }

    /**
     * 点击事件
     *
     * @param v
     * @param data
     */
    @Override
    public void clickListener(View v, Object data) {
        switch (v.getId()) {
            case R.id.button_update://点击 修改
                bpaGoodsrecipename =(BPA_GOODSRECIPENAME)data;
                break;
            case R.id.button_item://删除按钮
                ArrayList<ResGoodsRecipe> re= QueryDB.GetGoodsSreciperecipeList(((BPA_GOODSRECIPENAME) data).id);
                for(ResGoodsRecipe item:re)
                {
                    QueryDB.DeleteGoodsSrecipe(item);
                }
                QueryDB.DeleteGoodsRecipeName((BPA_GOODSRECIPENAME) data);
                Initdata_pf();
                ToastUtils.info("删除成功");
                break;
        }
    }

    @Override
    public void clickListenerNew(View v, int k, Object data) {

    }
    //endregion
}
